package assignment09;

import org.gecode.*;
import org.gecode.gist.Gist;

import static org.gecode.Gecode.*;
import static org.gecode.GecodeEnumConstants.*;

class Sudoku extends Space {

    VarArray<SetVar> x;

    public Sudoku() {
        x = new VarArray<SetVar>(this, 9, SetVar.class, new IntSet(1,0),
            new IntSet(0, 80));

        for (SetVar s : x) {
            cardinality(this, s, 9,9);
        }

        SetVar universe = new SetVar(this, new IntSet(1,0), new IntSet(0,80));
        rel(this, SOT_DUNION, x, universe);

        for (int i=0; i<9; i++) {
            int row[] = new int[9];
            int col[] = new int[9];
            int block[] = new int[9];
            
            for (int j=0; j<9; j++) {
                row[j] = 9*i+j;
                col[j] = 9*j+i;
                block[j] = (i/3) * 3 + (i % 3) * 27
                           + (j/3) + (j % 3) * 9;
            }
                        
            IntSet row_s = new IntSet(row);
            IntSet col_s = new IntSet(col);
            IntSet block_s = new IntSet(block);
  
            for (SetVar s : x) {
                SetVar i1 = new SetVar(this, new IntSet(1,0), new IntSet(0,80));
                cardinality(this, i1, 1, 1);
                rel(this, s, SOT_INTER, row_s, SRT_EQ, i1);
                SetVar i2 = new SetVar(this, new IntSet(1,0), new IntSet(0,80));
                cardinality(this, i2, 1, 1);
                rel(this, s, SOT_INTER, col_s, SRT_EQ, i2);
                SetVar i3 = new SetVar(this, new IntSet(1,0), new IntSet(0,80));
                cardinality(this, i3, 1, 1);
                rel(this, s, SOT_INTER, block_s, SRT_EQ, i3);
            }
            
        }

        branch(this, x, SETBVAR_NONE, SETBVAL_MIN);
    }
    
    public String toString() {
        String ret = "";
        for (int i=0; i<9; i++) {
            for (int j=0; j<9; j++) {
                int k=1;
                for (SetVar s:x) {
                    if (s.contains(i*9+j)) {
                        ret += k;
                        break;
                    }
                    k++;
                }
            }
            ret += "\n";
        }
        
        return ret;
    }
    
    public Sudoku(Boolean share, Sudoku t) {
        super(share, t);
        x = new VarArray<SetVar>(this, share, t.x);
    }
    
    public static void main(String[] args) {
        Gist g = new Gist(new Sudoku());
        g.exploreOne();
    }
    
}
